#!/bin/bash
## for some reason, we cannot simply do this above:  #!/bin/gawk --re-interval -f
script=${0##*/}
script=${script%.cgi}
exec /bin/gawk -v SCRIPT=${script} --re-interval -f - -- $@ <<ENDOFFILE

function dumpenv(  i) {
	print						>>LOGFILE;
	print "----"strftime()" New Request: --------"	>>LOGFILE;
	for (i = 0; i < ARGC; ++i)
		print "ARGV["i"]="ARGV[i]		>>LOGFILE;
	for (i in ENVIRON) {
		if (ENVIRON[i] != "")
			print i"="ENVIRON[i]		>>LOGFILE;
	}
	print						>>LOGFILE;
}

function log_print(text) {
	print text >>LOGFILE;
	print text;
}

function queue_body(text  ,i) {
	if (substr(text,1,1) != "<") {
		while (i = match(text, "..........[ \n\t]")) {
			BODY[BODYX++] = substr(text,1,i+9);
			text = substr(text,i+10);
		}
	}
	if (text != "") {
		BODY[BODYX++] = text;
	}
}

function queue_head(text) {
	HEAD = HEAD text;
}

function queue_tail(text) {
	TAIL = TAIL text;
}

function merge_body(start_offset  ,i,out) {
	if (start_offset && substr(TAIL,1,9) != "</select>")
		out = "...";
	for (i = start_offset; i < BODYX; ++i) {
		out = out BODY[i];
	}
	return gensub("\n","<br/>","g",out);
}

function shrink_body(bytes  ) {
	print "-----------SHRINK="bytes >>LOGFILE;
	while (BODYX > 0 && 0 < (bytes -= length(BODY[--BODYX]))) ;
	return BODYX;
}

function get_filesize(path  ,ls,size,s) {
	ls = "/bin/ls -l '"path"' 2>/dev/null";
	ls | getline size;
	close(ls);
	return (split(size,s) >= 9) ? s[5] : 0;
}

function do_compile(wml  ,compiler,size) {
	WMLC_FILE = "/tmp/"ARGV[0]"."PROCINFO["pid"]".wmlc";
	compiler = "/ulb/wmlc - '"WMLC_FILE"' 2>/dev/null";
	print wml | compiler;
	close(compiler);
	size = get_filesize(WMLC_FILE);
	print "-----------WMLC="size"/"MAX_DECKSIZE" bytes" >>LOGFILE;
	return size;
}

function get_output_size(text) {
	print "-----------TEXT="length(text)"/"MAX_DECKSIZE" bytes" >>LOGFILE;
	if (CONTENT_TYPE == "application/vnd.wap.wmlc")
		return do_compile(text);
	return length(text);
}

function generate_more_link(include_hints  ,more,dots) {
	more = "";
	dots = " ...";
	if (include_hints && START_OFFSET == 0) {
		if (substr(TAIL,1,9) == "</select>") {
			more = "<option onpick=\"" URL "="HINTS"\">Hints</option>";
		} else {
			more = dots "<br/><a href=\"" URL "="HINTS"\">Hints</a>";
			dots = "";
		}
	}
	if (substr(TAIL,1,9) == "</select>")
		more = more "<option onpick=\"" URL "=XXXXXX\">More..</option>";
	else
		more = more dots "<br/><a href=\"" URL "=XXXXXX\">More</a>";
	return more;
}

function do_exit() {
	if (CONTENT_TYPE == "text/html") {
		queue_tail("</p></body></html>");
	} else {
		queue_tail("</p></card></wml>");
	}
	log_print("Content-Type: "CONTENT_TYPE";charset=iso-8859-1");
	log_print("");

	MAX_DECKSIZE -= 50; ## needed by some WAP gateways (eg. clearnet):
	text = HEAD merge_body(START_OFFSET) TAIL;
	while ((size = get_output_size(text)) >= MAX_DECKSIZE) {
		more = generate_more_link(HINTS);
		delta = size + length(more) + 1 - MAX_DECKSIZE;
		next_offset = shrink_body(delta);
		if (START_OFFSET == 0 && HINTS && next_offset > HINTS) {
			more = generate_more_link(0);	## Get rid of the [Hints] link
		}
		gsub("XXXXXX", next_offset, more);
		text = HEAD merge_body(START_OFFSET) more TAIL;
	}

	if (CONTENT_TYPE == "application/vnd.wap.wmlc") {
		system("/bin/cat '"WMLC_FILE"' 2>/dev/null");
		system("/bin/rm -f '"WMLC_FILE"' &>/dev/null");
	} else {
		print text;
	}
	print text >>LOGFILE;
	exit(0);
}

function error_exit(text) {
	queue_head("<p>");
	queue_body(text);
	do_exit();
}

function quote(text) {
	## First, un-quote (most) existing quoted special chars:
	gsub("[&]nbsp;"," ",text);
	gsub("[&]amp;",AMP,text);
	gsub("[&]quot;","\"",text);
	gsub("[&]gt;",">",text);
	gsub("[&]lt;","<",text);
	gsub("[&]deg;","°",text);

	## Convert unrecognized quoted patterns into spaces:
	gsub("[&][a-z]{1,4};"," ",text);

	## Now quote any standalone amphersands:
	gsub("[&]", AMP"amp;", text);

	## Now, requote special characters:
	gsub("\"", AMP"quot;", text);	## double quote
	gsub("[<]", AMP"lt;", text);	## less-than symbol
	gsub(">", AMP"gt;", text);	## greater-than symbol
	if (CONTENT_TYPE != "text/html") {
		gsub("[\$]", "\$\$", text);	## dollar sign
		gsub("[^\n[:print:]]", " ", text);
	}

	## Strip excess spaces:
	gsub("  *", " ", text);
	gsub("(^ *)|( *$)|(^ *$)", "", text);
	return text;
}

function fetch_url(url  ,cmd,line,file) {
	file = "";
	cmd = "/ulb/wget-1.9 -nd -nH -U 'Mozilla/5.0 (compatible)' -O- \""url"\" 2>/dev/null";
	print "---------"cmd >>LOGFILE;
	while (cmd | getline line > 0) {
		file = file" "line;
	}
	close(cmd);
	gsub("[]"," ",file);
	gsub("  *"," ",file);
	if (file == "" && url ~ "^http[:]//www[.]geocaching[.]com/.*")
		error_exit("geocaching site not responding");
	return file;
}

function read_file(fname  ,file,line) {
	file = "";
	while (getline line <fname > 0) {
		file = file" "line;
	}
	close(fname);
	gsub(""," ",file);
	gsub("  *"," ",file);
	return file;
}

function mobile_max_size(  max,url,fname,model,agent) {
	if ("HTTP_X_WAP_PROFILE" in ENVIRON)
		url = ENVIRON["HTTP_X_WAP_PROFILE"];
	if (url == "" && "HTTP_PROFILE" in ENVIRON)
		url = ENVIRON["HTTP_PROFILE"];
	if (url == "") {
		agent = ENVIRON["HTTP_USER_AGENT"];
		if (substr(agent,1,5) == "Nokia") {
			model = substr(agent,6,4);
			if (substr(agent,10,1) == "/") {
				sub("^Nokia..../","",agent);
				sub(" .*","",agent);
				if (agent != "") {
					url = "http://nds.nokia.com/uaprof/N"model"r"(agent * 100)".xml";
				}
			}
		}
	}
	if (url != "") {
		sub("^\"","",url);
		sub("\"$","",url);
		fname = "/html/geo/handsets/"gensub(".*/","","g",url);
		file = read_file(fname);
		if (file == "") {
			file = fetch_url(url);
			if (file != "") {
				print file >fname;
			}
		}
		if (gsub("^.*[<]prf[:]WmlDeckSize>","",file) && gsub("[<]/prf[:]WmlDeckSize>.*$","",file)) {
			max = toupper(file);
			gsub(" ","",max);
			gsub("KB","000",max);
		}
	}
	if (max == "" && "HTTP_X_UP_DEVCAP_MAX_PDU" in ENVIRON)
		max = ENVIRON["HTTP_X_UP_DEVCAP_MAX_PDU"];
	gsub("[^0-9]","",max);
	if (max == "" || (max + 0) == 0) {
		if (CONTENT_TYPE == "text/html")
			max = 9999;
		else
			max = 1492;
	}
	return max;
}

function find_span(line,span   ,pattern) {
	pattern = "^[<]span id=\""span"\"> *";
	if (line ~ pattern".*") {
		span = gensub(pattern, "", 1, line);
		sub(" *[<]/span>.*", "", span);
		return span;
	}
	return "";
}

function prepare_header(cardid, title)
{
	if (CONTENT_TYPE == "text/html") {
		queue_head("<html><title>"title"</title><body>");
	} else {
		queue_head("<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>");
		queue_head("<!DOCTYPE wml PUBLIC \"-//WAPFORUM//DTD WML 1.1//EN\" \"http://www.WAPforum.org/DTD/wml_1.1.xml\">");
		queue_head("<wml>");
		queue_head("<card id=\""cardid"\" title=\""title"\">");
		queue_head("<do type=\"prev\"><prev/></do>");
	}
}

function find_caches(show_owner,title,query  ,url,file,t,cachetype,distance,name,waypoint) {
	prepare_header("caches", title);
	url = "http://www.geocaching.com/seek/"query
	file = fetch_url(url);
	if (GENERIC) {
		queue_head("<p>ZZ");
	} else {
		queue_head("<p mode=\"nowrap\">ZZ");
		if (CONTENT_TYPE == "application/vnd.wap.wmlc") {
			## Openwave browser rejects this construct in .wml, but not when precompiled:
			queue_head("<do type=\"accept\" label=\"VIEW\"><go/></do>");
		}
		queue_head("<select name=\"cachelist\" title=\""title":\">");
	}
	num_found = 0;
	while ((i = index(file, "images/WptTypes")) != 0) {
		file = substr(file,i);
		sub("^[^\"]*\" alt=\"","",file);
		cachetype = toupper(gensub("[^a-zA-Z].*$","",1,file));
		t = match(file,"[<]td valign[^>]* nowrap>[(][0-9./]*[)][<]/td>");
		if (t != 0) {
			file = substr(file,t+1);
			difficulty = gensub("[^>]*>[(]","",1,file);
			sub("[)][<].*$","",difficulty);
			split(difficulty,d,"/");
			difficulty = int(d[1]+0.5)"/"int(d[2]+0.5);
			delete d;
			## skip over date placed:
			t = match(file,"[<]td valign");
			file = substr(file,t+1);
			## find distance:
			t = match(file,"[<]td valign");
			if (t != 0) {
				file = substr(file,t+1);
				distance = gensub("^[^>]*>","",1,file);
				sub("&nbsp;<br>","_",distance);
				sub("^0[.]",".",distance);
				sub("[<].*$","",distance);
				if (distance ~ "[hH]ere")
					distance = "0ft";
				if (MILES == 0) {
					if (distance ~ "[0-9.]*mi") {
						distance = substr(distance,1,length(distance)-2) * 1.609;
						if (distance >= 9.5)
							distance = int(distance + 0.5);
						else
							distance = sprintf("%.1f", distance);
						sub("[.]0$","",distance);
						distance = distance"km";
					} else if (distance ~ "[0-9.]*ft") {
						distance = int(0.5 + (substr(distance,1,length(distance)-2) * 0.3048));
						distance = distance"m";
					}
				}
				t = index(file,"/cache_details.aspx?");
				if (t != 0) {
					file = substr(file,t);
					sub("^[^>]*>","",file);
					if (substr(file,1,8) != "<strike>") {
						name = gensub("<.*$","",1,file);
						sub("^[^<]*[<]/a>","",file);
						sub("^[ 	]*","",file);
						owner = "";
						if (show_owner && substr(file,1,3) == "by ") {
							owner = " "quote(gensub(" *[<].*$","","1",file));
						}
						t = match(file,"[(]GC[A-Z0-9]{1,4}[)][<]br>");
						if (t != 0) {
							file = substr(file,t+1);
							waypoint = gensub("[)].*$","",1,file);
							if (GENERIC) {
								cachetype = substr(cachetype,1,4);
								line = cachetype" "quote(distance" "difficulty" "name" "owner)"\n";
								if (CONTENT_TYPE != "text/html")
									line = line "-----\n";
								line = "<a href=\"/"SCRIPT"?"waypoint"\">"waypoint"</a> "line;
							} else {
								cachetype = substr(cachetype,1,1);
								line = quote(cachetype":"waypoint" "distance" "difficulty" "name owner);
								line = "<option onpick=\"/"SCRIPT"?"waypoint"\">"line"</option>";
							}
							queue_body(line);
							++num_found;
						}
					}
				}
			}
		}
	}
	sub("ZZ", num_found ? "" : "No caches found", HEAD);
	queue_tail((GENERIC ? "\n" : "</select>"));
	do_exit();
}

function get_wp_latlon(wp  ,file,t,espan,line,latlon,a) {
	file = fetch_url("http://www.geocaching.com/seek/cache_details.aspx?pf=y&wp="wp"&log=n&decrypt=n");
	while (0 != (start = index(file,"<span id="))) {
		espan = "</span>";
		if (0 == (end = index(file,espan)))
			end = length(file) - espan - 1;
		end += length(espan) - 1;
		line = substr(file,start,end);
		file = substr(file,end+1);

		if ((t = find_span(line, "LatLon")) != "") {
			latlon = gensub("[<][^>]+>","","g",t);
			if (split(latlon,a," ") >= 6) {
				gsub("[^0-9]","",a[2]);
				gsub("[^0-9]","",a[5]);
				a[2] = substr("0",length(a[2]))a[2];
				a[5] = substr("00",length(a[5]))a[5];
				latlon = a[1]a[2]"_"a[3]"'+"a[4]a[5]"_"a[6]"'";
				return gensub(" ","","g",latlon);
			}
			delete a;
		}
	}
	error_exit(wp": not found");
}

function view_cache(wp  ,file,t,espan,name,owner,size,difficulty,terrain,short,description,waypoint,hints,latlon,a,logs) {
	file = fetch_url("http://www.geocaching.com/seek/cache_details.aspx?pf=y&wp="wp"&log=y&numlogs=6&decrypt=y");
	t = gensub("^.*images/WptTypes/[^>]*ALT=","",1,file);
	if (substr(t,1,1) == "\"") {
		cachetype = toupper(gensub("[\" ].*$","",1,substr(t,2)));
	}
	while (0 != (start = index(file,"<span id="))) {
		espan = "</span>";
		if (0 == (end = index(file,espan)))
			end = length(file) - espan - 1;
		end += length(espan) - 1;
		line = substr(file,start,end);
		file = substr(file,end+1);

		if ((t = find_span(line, "ErrorText")) != "") {
			errortext = quote(gensub("[<][^>]+>"," ","g",t));
		}
		if ((t = find_span(line, "LatLon")) != "") {
			latlon = gensub("[<][^>]+>","","g",t);
			if (split(latlon,a," ") >= 6) {
				lon = quote(a[4]a[5]a[6]"'");
				lat = quote(a[1]a[2]a[3]"'");
			}
			delete a;
			latlon = lat"\n"lon;
		}
		if ((t = find_span(line, "CacheName")) != "") {
			name = gensub(" *[<[].*", "", 1, t);
			name = quote(toupper(name));
		}
		if ((t = find_span(line, "CacheOwner")) != "") {
			if (cachetype != "VIRTUAL") {
				size = toupper(gensub(".*Size: *", "", 1, t));
				sub(" *[<[].*", "", size);
				if (size == "UNKNOWN" || size == "OTHER") {
					size = "";
				} else if (size == "REGULAR") {
					size = "RegSize";
				}  ## MICRO, LARGE
			}
			owner = gensub(".*[<]br>by ", "", 1, t);
			sub(" *[<[].*", "", owner);
			owner = quote(owner);
		}
		if ((t = find_span(line, "WaypointName")) != "") {
			waypoint = toupper(gensub(" *[<[].*", "", 1, t));
		}
		if ((t = find_span(line, "Difficulty")) != "") {
			difficulty = gsub("images/star", "", t);
			if (sub("images/halfstar", "", t))
				difficulty = difficulty"+";
		}
		if ((t = find_span(line, "Terrain")) != "") {
			terrain = gsub("images/star", "", t);
			if (sub("images/halfstar", "", t))
				terrain = terrain"+";
		}
		if ((t = find_span(line, "ShortDescription")) != "") {
			short = quote(gensub("[<][^>]+>"," ","g",t));
		}
		if ((t = find_span(line, "LongDescription")) != "") {
			description = quote(gensub("[<][^>]+>"," ","g",t));
		}
		if ((t = find_span(line, "Hints")) != "") {
			hints = quote(gensub("[<][^>]+>"," ","g",t));
		}
		if ((t = find_span(line, "CacheLogs")) != "") {
			gsub("[<]STRONG>[<][iI][mM][gG] [^>]*icon_happy[^>]*>","\n\nFOUND: ",t);
			gsub("[<]STRONG>[<][iI][mM][gG] [^>]*icon_sad[^>]*>","\n\nNOT-FOUND: ",t);
			gsub("[<]STRONG>[<][iI][mM][gG] [^>]*icon_note[^>]*>","\n\nNOTE: ",t);
			gsub(">User's web page[<]","><",t);
			logs = quote(gensub("[<][^>]+>"," ","g",t));
		}
	}
	if (waypoint != wp)
		error_exit(wp": not found");
	queue_head("<p>");
	queue_body(toupper(waypoint)" "name" by "owner);
	if (cachetype != "" && cachetype != "TRADITIONAL")
		queue_body(", "cachetype);
	queue_body(", D"difficulty"/T"terrain);
	if (size != "")
		queue_body(", "size);
	if (latlon != "")
		queue_body("\n"latlon);
	if (errortext != "")
		queue_body("\n"errortext);
	if (short != "")
		queue_body("\n"short);
	if (description != "")
		queue_body("\n"description);
	if (hints != "") {
		HINTS = BODYX;
		queue_body("\n\nHINTS: "hints);
	}
	if (logs != "") {
		queue_body("\n\nRECENT LOGS: "logs);
	}
	queue_body("\n");
	do_exit();
}

function view_tbug(target  ,tagnum,t,file,name,owner,start,end,text,origin,distance,logs) {
	tagnum = gensub("^((TB)|(TAG))","",1,target);
	file = fetch_url("http://www.geocaching.com/track/track.asp?tracker="tagnum);

	## Extract the travel bug name:
	name = gensub(".*[<]title>[^:]*: *","",1,file);
	sub("[<].*$","",name);
	name = quote(name);

	## Extract the owner:
	owner = gensub(".*[<]STRONG>Released:[<]/STRONG>[^b]*by [<][^>]*>","",1,file);
	sub("[<].*$","",owner);
	owner = quote(owner);

	## Extract the travel bug goal and description texts:
	t = "read how to use a Travel Bug";
	start = index(file,t);
	if (start == 0)
		error_exit(target": not found");
	text = substr(file,start+length(t));
	end = index(text,"Track Images");
	if (end == 0) {
		end = index(text,"Total distance travelled");
		if (end == 0) {
			end = index(text,"Recent sightings:");
			if (end == 0) {
				error_exit(target": error during retrieval");
			}
		}
	}
	logs = substr(text,end);
	text = substr(text,1,end-1);
	text = quote(gensub("[<][^>]+>","","g",text));
	sub("^[.]","",text);

	sub("^.*log your own","",logs);
	gsub("[<[aA] [hH][rR][eE][fF][=]'http://img.groundspeak.com/track/log[^>]*>[^<]*[<]/[aA]>","",logs);
	gsub("[<]STRONG>","\n\n",logs);
	gsub("[<]p>[&]nbsp;[<]/p>.*$","",logs);
	logs = gensub("[<][^>]+>"," ","g",logs);
	gsub(" *\n *","\n",logs);
	gsub("\n\n\n*","\n\n",logs);
	logs = quote(logs);
	gsub("\n\n\n*","\n\n",logs);

	## Extract the origin:
	origin = gensub(".*[<]STRONG>Origin: *[<]/STRONG> *","",1,file);
	sub("[<].*$","",origin);
	origin = quote(origin);

	## Extract the distance travelled:
	distance = gensub(".*>Total distance travelled:  *","",1,file);
	sub("[<].*$","",distance);
	distance = quote(distance);

	queue_head("<p>");
	queue_body(target" "name);
	if (owner != "")
		queue_body(" by "owner".");
	if (origin != "")
		queue_body("\nORIGIN "origin".");
	if (distance != "")
		queue_body("\nTRAVELLED "distance".");
	if (text != "")
		queue_body("\n"text);
	if (logs != "")
		queue_body("\n\nLOGS:"logs);
	queue_body("\n");
	do_exit();
}

## main()
BEGIN {
	START_OFFSET = 0;
	LOGFILE = "/var/log/httpd/geo.log";
	GENERIC = (0 == index(ENVIRON["HTTP_USER_AGENT"], "UP.Browser"))
	query = ENVIRON["QUERY_STRING"];
	if (query == "")
		query = ARGV[1];
	query = toupper(query);
	START_OFFSET = index(query,"=");
	if (START_OFFSET) {
		START_OFFSET = 0 + substr(query,START_OFFSET+1);
		sub("[=].*$","",query);
	}
	URL = "/"SCRIPT"?"query;	## used in do_exit()
	AMP="\\\&";
	dumpenv();
	if (ENVIRON["HTTP_X_UP_SUBNO"] == "Mark Lord_vmware-ibbm.localnet") {
		CONTENT_TYPE = "application/vnd.wap.wmlc";
		MAX_DECKSIZE = 1500;
	} else {
		t = ENVIRON["HTTP_ACCEPT"]" ";
		if (match(t,"application/vnd.wap.wmlc[^a-z.]")) {
			CONTENT_TYPE = "application/vnd.wap.wmlc";
		} else if (match(t,"text/vnd.wap.wml[^a-z.]")) {
			CONTENT_TYPE = "text/vnd.wap.wml";
		} else {
			CONTENT_TYPE = "text/html";
		}
	}
	if (MAX_DECKSIZE == 0)
		MAX_DECKSIZE = mobile_max_size();
	print "--------- MAX_DECKSIZE="MAX_DECKSIZE >>LOGFILE;
	if (query == "") {
		if (CONTENT_TYPE == "text/html") {
			cmd = "/bin/cat /html/geo/index.html";
		} else {
			CONTENT_TYPE = "text/vnd.wap.wml";
			if (GENERIC) {
				file = "/html/geo/gen0.wml";
				if (get_filesize(file) > (MAX_DECKSIZE - 50))
					file = "/html/geo/gen1.wml";
			} else {
				file = "/html/geo/ow0.wml";
				if (get_filesize(file) > (MAX_DECKSIZE - 50))
					file = "/html/geo/ow1.wml";
			}
			cmd = "/bin/sed -e's/geo[?]/"SCRIPT"?/g' " file;
		}
		log_print("Content-Type: "CONTENT_TYPE);
		log_print("");
		print "----------> "cmd" 2>/dev/null" >>LOGFILE;
		system(cmd" 2>/dev/null");
		exit(0);
	}
	t = gensub("([%]..)+","_","g",query);
	if (query ~ "^GC[A-Z0-9]{1,4}$") {
		prepare_header(query, query);
		view_cache(query);
	} else if (query ~ "((TB)|(TAG))[0-9]{6}$") {
		prepare_header(query, query);
		view_tbug(query);
	} else if (query ~ "U[+]..*") {
		t = substr(query,3);
		find_caches(0, "By "t, "nearest.aspx?u="t"&submit4=Find");
	} else if (query ~ "Z[+][0-9]{3,5}") {
		MILES = 1;
		t = substr(query,3);
		find_caches(0, t, "nearest.aspx?zip="t"&dist=100");
	} else if (t ~ "P[+]([A-Z]_*[0-9]){2}") {
		t = substr(t,3);
		gsub("[ _]","",t);
		find_caches(0, t, "nearest.aspx?zip="substr(t,1,3)"+"substr(t,4,3)"&dist=100");
	} else {
		if (t ~ "WP[+]GC[A-Z0-9]{1,4}") {
			t = get_wp_latlon(substr(t,4));
		}
		n = split(t,q,"[+]");
		if (n == 2 && q[1] ~ "[NS][^0-9]*[0-9]+[^0-9]+[0-9]+[.][0-9]+[^0-9]*") {
			lat = latlon_query(q[1],"lat","ns");
			if (q[2] ~ "[WE][^0-9]*[0-9]+[^0-9]+[0-9]+[.][0-9]+[^0-9]*") {
				lon = latlon_query(q[2],"long","ew");
				find_caches(1, "Nearest Caches", "nearest.aspx?"lat"&"lon);
				exit(0);
			}
		}
		prepare_header("Error", "Error");
		error_exit("Bad parameters: "query);
	}
	exit(0);
}

function latlon_query(s,p,y  ,f) {
	s = tolower(s);
	f = p"_"y"=" ((substr(s,1,1) == substr(y,1,1)) ? "1" : "-1");
	sub("^[^0-9]*","",s);
	f = f"&"p"_h="gensub("[^0-9].*$","",1,s);
	sub("^[0-9]+[^0-9]+","",s);
	return f"&"p"_mmss="gensub("[^0-9]*$","",1,s);
}

ENDOFFILE
